// Java class com.proton.gopenpgp.crypto.PGPMessage is a proxy for talking to a Go program.
//   gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/gopenpgp/v2/crypto
//
// File is generated by gobind. Do not edit.
package com.proton.gopenpgp.crypto;

import go.Seq;

/**
 * PGPMessage stores a PGP-encrypted message.
 */
public final class PGPMessage implements Seq.Proxy {
	static { Crypto.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	/**
	 * NewPGPMessage generates a new PGPMessage from the unarmored binary data.
	 */
	public PGPMessage(byte[] data) {
		this.refnum = __NewPGPMessage(data);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewPGPMessage(byte[] data);
	
	/**
	 * NewPGPMessageFromArmored generates a new PGPMessage from an armored string ready for decryption.
	 */
	public PGPMessage(String armored) {
		this.refnum = __NewPGPMessageFromArmored(armored);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewPGPMessageFromArmored(String armored);
	
	PGPMessage(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * The content of the message
	 */
	public final native byte[] getData();
	/**
	 * The content of the message
	 */
	public final native void setData(byte[] v);
	
	/**
	 * GetArmored returns the armored message as a string.
	 */
	public native String getArmored() throws Exception;
	/**
	 * GetArmoredWithCustomHeaders returns the armored message as a string, with
	the given headers. Empty parameters are omitted from the headers.
	 */
	public native String getArmoredWithCustomHeaders(String comment, String version) throws Exception;
	/**
	 * GetBinary returns the unarmored binary content of the message as a []byte.
	 */
	public native byte[] getBinary();
	// skipped method PGPMessage.NewReader with unsupported parameter or return types
	
	/**
	 * SeparateKeyAndData returns the first keypacket and the (hopefully unique)
	dataPacket (not verified).
	* estimatedLength is the estimate length of the message.
	* garbageCollector &gt; 0 activates the garbage collector.
	 */
	public native PGPSplitMessage separateKeyAndData(long estimatedLength, long garbageCollector) throws Exception;
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof PGPMessage)) {
		    return false;
		}
		PGPMessage that = (PGPMessage)o;
		byte[] thisData = getData();
		byte[] thatData = that.getData();
		if (thisData == null) {
			if (thatData != null) {
			    return false;
			}
		} else if (!thisData.equals(thatData)) {
		    return false;
		}
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {getData()});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("PGPMessage").append("{");
		b.append("Data:").append(getData()).append(",");
		return b.append("}").toString();
	}
}

