// Java class com.proton.gopenpgp.crypto.SessionKey is a proxy for talking to a Go program.
//   gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/gopenpgp/v2/crypto
//
// File is generated by gobind. Do not edit.
package com.proton.gopenpgp.crypto;

import go.Seq;

/**
 * SessionKey stores a decrypted session key.
 */
public final class SessionKey implements Seq.Proxy {
	static { Crypto.touch(); }
	
	private final int refnum;
	
	@Override public final int incRefnum() {
	      Seq.incGoRef(refnum, this);
	      return refnum;
	}
	
	public SessionKey(byte[] token, String algo) {
		this.refnum = __NewSessionKeyFromToken(token, algo);
		Seq.trackGoRef(refnum, this);
	}
	
	private static native int __NewSessionKeyFromToken(byte[] token, String algo);
	
	SessionKey(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
	
	/**
	 * The decrypted binary session key.
	 */
	public final native byte[] getKey();
	/**
	 * The decrypted binary session key.
	 */
	public final native void setKey(byte[] v);
	
	/**
	 * The symmetric encryption algorithm used with this key.
	 */
	public final native String getAlgo();
	/**
	 * The symmetric encryption algorithm used with this key.
	 */
	public final native void setAlgo(String v);
	
	public native boolean clear();
	/**
	 * Decrypt decrypts password protected pgp binary messages.
	* encrypted: PGPMessage.
	* output: PlainMessage.
	 */
	public native PlainMessage decrypt(byte[] dataPacket) throws Exception;
	/**
	 * Encrypt encrypts a PlainMessage to PGPMessage with a SessionKey.
	* message : The plain data as a PlainMessage.
	* output  : The encrypted data as PGPMessage.
	 */
	public native byte[] encrypt(PlainMessage message) throws Exception;
	/**
	 * GetBase64Key returns the session key as base64 encoded string.
	 */
	public native String getBase64Key();
	// skipped method SessionKey.GetCipherFunc with unsupported parameter or return types
	
	@Override public boolean equals(Object o) {
		if (o == null || !(o instanceof SessionKey)) {
		    return false;
		}
		SessionKey that = (SessionKey)o;
		byte[] thisKey = getKey();
		byte[] thatKey = that.getKey();
		if (thisKey == null) {
			if (thatKey != null) {
			    return false;
			}
		} else if (!thisKey.equals(thatKey)) {
		    return false;
		}
		String thisAlgo = getAlgo();
		String thatAlgo = that.getAlgo();
		if (thisAlgo == null) {
			if (thatAlgo != null) {
			    return false;
			}
		} else if (!thisAlgo.equals(thatAlgo)) {
		    return false;
		}
		return true;
	}
	
	@Override public int hashCode() {
	    return java.util.Arrays.hashCode(new Object[] {getKey(), getAlgo()});
	}
	
	@Override public String toString() {
		StringBuilder b = new StringBuilder();
		b.append("SessionKey").append("{");
		b.append("Key:").append(getKey()).append(",");
		b.append("Algo:").append(getAlgo()).append(",");
		return b.append("}").toString();
	}
}

